Require Export compare_correct.

Module ADD_CORRECT(Nums : NUMS).

Module Compare_correct := COMPARE_CORRECT(Nums).
Export Compare_correct.

(*(*computes (x+y+r)/b*)
CoFixpoint sum_div_base_ (x y: stream digit) (r : digit) :
  stream digit := 
  (match (x, y) with 
    | (k1::x', k2::y') => 
      let s:=(Dplus_ k1 k2) in
	let q := Dlow (Dplus_ r (Dhigh s))  in let r' := Dlow s in 
	  match Dmax ?= r' with 
	    | Eq => (Dlow (Dplus_ q 1))::sum_div_base_ x' y' (-(1))
	    | _ => 
	      match - Dmax ?= r' with 
		| Eq => (Dlow (Dplus_ q (-(1))))::sum_div_base_ x' y' 1
		| _ => q::sum_div_base x' y' r'
	      end
	  end
  end)%D.

Theorem sum_div_base_correct_ :
  forall r x y vx vy,
    ( - b+2 <= IDZ r <= b - 2)%Z ->
    Srepresents x vx ->
    Srepresents y vy ->
    Srepresents (sum_div_base_ x y r) ((vx+vy+IDR r)/Z2R b)%R.
Proof.
cofix.
intros r x y vx vy Hr Hrepx Hrepy.
str_unfold (sum_div_base_ x y r).
destruct x as [k x'].
destruct y as [l y'].
inversion Hrepx; inversion Hrepy; subst.
simpl.
compare_eq_tac G1.
*)






(* (*computes (x+y+r)/b*) *)
(* CoFixpoint sum_div_base_ (x y: stream digit) (r : digit) : *)
(*   stream digit :=  *)
(*   match (x, y) with  *)
(*     | (k1::x', k2::y') => *)
(*       let z := Dplus_ k1 k2 in *)
(* 	(r+Dhigh z)::sum_div_base_ x' y' (Dhigh z) *)
(*   end. *)


(* Axiom plus_IDZ_ :  *)
(*   forall m n,  *)
(*     (- IDZ b <  IDZ m < IDZ b ->  *)
(*       - IDZ b <  IDZ n < IDZ b -> *)
(*       IDZ m + IDZ n = IDZ (Dlow (Dplus_ m n)) + IDZ b * IDZ (Dhigh (Dplus_ m n)) /\ *)
(*       - IDZ b < IDZ (Dlow (Dplus_ m n)) < IDZ b /\ *)
(*       - 1 <= IDZ (Dhigh (Dplus_ m n)) <= 1)%Z. *)

(* Theorem sum_div_base_correct_ :  *)
(*   (2 < IDZ b)%Z -> *)
(*   forall r x y vx vy, *)
(*     ( -IDZ b+2 <= IDZ r <= IDZ b - 2)%Z -> *)
(*     Srepresents x vx ->  *)
(*     Srepresents y vy ->  *)
(*     Srepresents (sum_div_base_ x y r) ((vx+vy+IDR r)/IDR b)%R. *)
(* Proof. *)
(* intros Hbpos. *)
(* cofix. *)
(* intros r x y vx vy Hr Hrepx Hrepy. *)
(* str_unfold (sum_div_base_ x y r). *)
(* destruct x as [k x']. *)
(* destruct y as [l y']. *)
(* inversion Hrepx; inversion Hrepy; subst. *)
(* simpl. *)
(* generalize (plus_IDZ_ k l H4 H10). *)
(* intros [U1 [U2 U3]]. *)
(* assert (U4 : 3 <= IDR b) by IDR_to_Z. *)
(* replace (((IDR k + r0) / IDR b + (IDR l + r1) / IDR b + IDR r) / IDR b) with  *)
(*   ((IDR (Dlow (Dplus_ k l)) + (r0 + r1 + IDR (Dhigh (Dplus_ k l)))/IDR b)/IDR b). *)
(* constructor; [apply sum_div_base_correct_; assumption || omega  *)
(*   | clear sum_div_base_correct_ | assumption]. *)

(* apply Rle_div_1; [fourier|]. *)
(* assert (-1 <= IDR (Dhigh (Dplus_ k l)) <= 1)%R by (split; IDR_to_Z). *)
(* dec_tac; split; fourier. *)

(* field_simplify_eq; [| ZR0compat]. *)
(* Admitted. *)

Theorem find_sum_remainder_correct : 
  forall x1 y1, 
    (-b  < IDZ x1 < b ->
      -b < IDZ y1 < b ->
      let (q,r') := find_sum_remainder x1 y1 in 
        IDZ q * b + IDZ r' = IDZ x1 + IDZ y1 /\ 
        -1 <= IDZ q <= 1 /\ 
        -b + 2 <= IDZ r' <= b - 2)%Z.
Proof.
intros x1 y1 Hx1 Hy1.
assert (Hbpos := base_positive).
unfold find_sum_remainder.
compare_lt_tac G1; [compare_gt_tac G2|];
  simpl_IDZ; (split; [ring |split; [intuition|try omega]]).
Qed.

Theorem sum_div_base_correct : 
  forall r x y vx vy,
    ( - b+2 <= IDZ r <= b - 2)%Z ->
    Srepresents x vx -> 
    Srepresents y vy -> 
    Srepresents (sum_div_base x y r) ((vx+vy+IDR r)/Z2R b)%R.
Proof.
assert (Hbpos := base_positive).
cofix.
intros r x y vx vy Hr Hrepx Hrepy.
str_unfold (sum_div_base x y r).
destruct x as [x1 x']; destruct y as [y1 y'];
  inversion Hrepx; inversion Hrepy; subst.
simpl.
fold_decomp.
generalize (find_sum_remainder_correct _ _ H4 H10).
caseEq (find_sum_remainder x1 y1); intros q r' Hqr' [U1 [U2 U3]].
replace (((IDR x1 + r0) / Z2R b + (IDR y1 + r1) / Z2R b + IDR r) / Z2R b) with 
  ((IDR (q+ r)%D + (r0 + r1 + IDR r')/ Z2R b)/ Z2R b).

constructor;[apply sum_div_base_correct| |]; 
  clear sum_div_base_correct; try assumption.
apply Rle_div_1; [R_to_Z|].
assert ( -Z2R b + 2 <= IDR r' <= Z2R b - 2) by (split; IDR_to_Z).
dec_tac; split; fourier.
simpl_IDZ; omega.

replace ((IDR x1 + r0) / Z2R b + (IDR y1 + r1) / Z2R b) with 
  (((IDR x1 +IDR y1) + r0 + r1) / Z2R b) by (unfold Rdiv; ring).
simpl_IDR.
replace (Z2R (IDZ x1) + Z2R (IDZ y1)) with (Z2R (IDZ x1 + IDZ y1)) by R_to_Z.
rewrite <- U1; field_IDR.
Qed.

Theorem Sadd_correct :
  forall x y vx vy, 
    Srepresents x vx -> 
    Srepresents y vy -> 
    (-1<= vx + vy <= 1)%R ->
    Srepresents (Sadd x y) (vx + vy)%R.
Proof.
pose (Hbpos := base_positive).
intros x y vx vy Hrepx Hrepy.
replace (vx+vy)%R with (Z2R b*((vx+vy+IDR 0%D)/Z2R b))%R; [idtac| field_IDR].
intros Haddxy.
unfold Sadd.
apply multb_correct; (assumption || omega||idtac).
apply sum_div_base_correct; try assumption; simpl_IDZ; omega.
Qed.

Theorem add_correct : 
  forall x y u v, 
    represents x u -> 
    represents y v -> 
    represents (add x y) (u + v)%R.
Proof.
pose (Hbpos := base_positive).
intros x y u v Hrepx Hrepy.
unfold add, exp_norm.
caseEq y; caseEq x.
intros e1 x' G1 e2 y' G2; subst.
inversion Hrepy; inversion Hrepx; subst.
elim (le_lt_dec e1 e2); intros G1.

replace (Z2R b ^ e1 * r0 + Z2R b ^ e2 * r) with 
  (Z2R b ^ (e2+1) * ((r0/Z2R b^(e2-e1)%nat + r+IDR 0%D)/Z2R b)).
constructor.
apply sum_div_base_correct; assumption || (simpl_IDZ; omega) || idtac.
apply str_add_zero_correct; try omega; assumption.
simpl_IDR; rewrite Rplus_0_r.
rewrite pow_minus.
rewrite pow_add.
rewrite pow_1.
field; unfold IDR; repeat split; ZR0compat.
assumption.
IDR_to_Z.

replace (Z2R b ^ e1 * r0 + Z2R b ^ e2 * r) with 
  (Z2R b ^ (e1+1) * ((r0+r/Z2R b^(e1-e2)%nat + IDR 0%D)/Z2R b)).
constructor.
apply sum_div_base_correct; assumption || (simpl_IDZ; omega) || idtac.
apply str_add_zero_correct; try omega; assumption.
simpl_IDR; rewrite Rplus_0_r.
rewrite pow_minus.
rewrite pow_add.
rewrite pow_1.
field; unfold IDR; repeat split; ZR0compat.
omega.
IDR_to_Z.
Qed.

Theorem sub_div_base_correct : 
  forall r x y vx vy,
    (- b+2 <= IDZ r <=  b-2)%Z ->
    Srepresents x vx -> 
    Srepresents y vy -> 
    Srepresents (sub_div_base x y r) ((vx-vy+IDR r)/Z2R b)%R.
Proof.
assert (Hbpos := base_positive).
cofix.
intros r x y vx vy Hr Hrepx Hrepy.
str_unfold (sub_div_base x y r).
destruct x as [x1 x']; destruct y as [y1 y'];
  inversion Hrepx; inversion Hrepy; subst.
simpl.
fold_decomp.
assert (U1 : (- b < IDZ (- y1)%D < b)%Z) by (simpl_IDZ; omega).
generalize (find_sum_remainder_correct _ _ H4 U1).
caseEq (find_sum_remainder x1 (-y1)%D); intros q r' Hqr' [U2 [U3 U4]].
replace (((IDR x1 + r0) / Z2R b - (IDR y1 + r1) / Z2R b + IDR r) / Z2R b) with 
  ((IDR (q+ r)%D + (r0 - r1 + IDR r')/ Z2R b)/ Z2R b).

constructor;[apply sub_div_base_correct| |]; 
  clear sub_div_base_correct; try assumption.
apply Rle_div_1; [R_to_Z|].
assert ( -Z2R b + 2 <= IDR r' <= Z2R b - 2) by (split; IDR_to_Z).
dec_tac; split; fourier.
simpl_IDZ; omega.

replace ((IDR x1 + r0) / Z2R b - (IDR y1 + r1) / Z2R b) with 
  (((IDR x1 -IDR y1) + r0 - r1) / Z2R b) by (unfold Rdiv; ring).
simpl_IDR.
replace (Z2R (IDZ x1) - Z2R (IDZ y1)) with (Z2R (IDZ x1 + IDZ (-y1)%D)) by IDR_to_Z.
rewrite <- U2; field_IDR.
Qed.

Theorem Ssub_correct :
  forall x y vx vy, 
    Srepresents x vx -> 
    Srepresents y vy -> 
    (-1<= vx - vy <= 1)%R ->
    Srepresents (Ssub x y) (vx - vy)%R.
Proof.
pose (Hbpos := base_positive).
intros x y vx vy Hrepx Hrepy.
replace (vx-vy)%R with (Z2R b*((vx-vy+IDR 0%D)/Z2R b))%R; [idtac| field_IDR].
intros Hsubxy.
unfold Ssub.
apply multb_correct; (assumption || omega||idtac).
apply sub_div_base_correct; try assumption; simpl_IDZ; omega.
Qed.

Theorem sub_correct : 
  forall x y u v, 
    represents x u -> 
    represents y v -> 
    represents (sub x y) (u - v)%R.
Proof.
pose (Hbpos := base_positive).
intros x y u v Hrepx Hrepy.
unfold sub, exp_norm.
caseEq y; caseEq x.
intros e1 x' G1 e2 y' G2; subst.
inversion Hrepy; inversion Hrepx; subst.
elim (le_lt_dec e1 e2); intros G1.

replace (Z2R b ^ e1 * r0 - Z2R b ^ e2 * r) with 
  (Z2R b ^ (e2+1) * ((r0/Z2R b^(e2-e1)%nat - r+IDR 0%D)/Z2R b)).
constructor.
apply sub_div_base_correct; assumption || (simpl_IDZ; omega) || idtac.
apply str_add_zero_correct; try omega; assumption.
simpl_IDR; rewrite Rplus_0_r.
rewrite pow_minus.
rewrite pow_add.
rewrite pow_1.
field; unfold IDR; repeat split; ZR0compat.
assumption.
IDR_to_Z.

replace (Z2R b ^ e1 * r0 - Z2R b ^ e2 * r) with 
  (Z2R b ^ (e1+1) * ((r0-r/Z2R b^(e1-e2)%nat + IDR 0%D)/Z2R b)).
constructor.
apply sub_div_base_correct; assumption || (simpl_IDZ; omega) || idtac.
apply str_add_zero_correct; try omega; assumption.
simpl_IDR; rewrite Rplus_0_r.
rewrite pow_minus.
rewrite pow_add.
rewrite pow_1.
field; unfold IDR; repeat split; ZR0compat.
omega.
IDR_to_Z.
Qed.

End ADD_CORRECT.
