Require Import digits_ex.
Require Import exact_newton.
Require Import String.
Open Scope string_scope.




Definition Highlighted (s:string) := 
  (String "027" "\033[38;5;0m\033[48;5;15m")  ++ s ++ "\033[38;5;15m\033[48;5;0m".


(*(String "027" "[0;31;48m") ++ s ++ (String "027" "[0;30;48m").
*)

(*******************************)

Eval compute in (Highlighted "Benchmark using the base 2^124 ").

Module Base_2_124 <: BASE.
Definition b := (2^124)%Z.
Theorem base_positive : (4 < b)%Z.
compute; auto.
Qed.
End Base_2_124.

Module digits_test := BIGZNUMS Base_2_124.

Module Test_computations := NEWTON digits_test.
(*Module Test_computations := EXACT_REAL_DEFINITIONS digits_test.*)
Import Test_computations.

(* Test of Sinverse *)
Eval compute in (Highlighted "4th digits of 1/(base * (3/7 + 5/9))").

Time Eval vm_compute in (Str_nth 20%nat 
  (Sinverse 1%nat ((Srat_to_stream (BigZ.of_Z 3) (BigZ.of_Z 7)) + (Srat_to_stream (BigZ.of_Z 5) (BigZ.of_Z 9)))%S)).

(* Test Szero *)
Eval compute in (Highlighted "1000th digits of Szero").

Time Eval vm_compute in (Str_nth 1000%nat Szero).

(* Test of Sone *)
Eval compute in (Highlighted "1000th digits of Sone").

Time Eval vm_compute in (Str_nth 1000%nat Sone).

(* Test of Sminus_one *)
Eval compute in (Highlighted "1000th digits of Sminus_one").

Time Eval vm_compute in (Str_nth 1000%nat Sminus_one).

(* Test of Sopp *)
Eval compute in (Highlighted "1000th digits of (Sopp Sone)").

Time Eval vm_compute in (Str_nth 1000%nat  (Sopp Sone) ).

(* Test of Sabs *)
Eval compute in (Highlighted "1000th digits of (Sabs Sminus_one)").

Time Eval vm_compute in (Str_nth 1000%nat  (Sabs Sminus_one) ).

(* Test of Smin *)
Eval compute in (Highlighted "1000th digits of (Smin Szero Sone)").

Time Eval vm_compute in (Str_nth 1000%nat (Smin Szero Sone)).

(* Test of Smax *)
Eval compute in (Highlighted "1000th digits of (Smax Szero Sone)").

Time Eval vm_compute in (Str_nth 1000%nat (Smax Szero Sone)).

(* Test of multb *)
Eval compute in (Highlighted "1000th digits of (multb (1::Szero))").

Time Eval vm_compute in (Str_nth 1000%nat (multb (1%D::Szero))).


(* Test of mult_digit *)
Eval compute in (Highlighted "1000th digits of (mult_digit (b/2) (1::Szero))").

Time Eval vm_compute in (Str_nth 1000%nat (mult_digit (fst (Bdiv_eucl Bbase (1+1)%B)) (1%D::Szero))).

(* Test of div_digit *)
Eval compute in (Highlighted "1000th digits of (div_digit Sone 3)").

Time Eval vm_compute in (Str_nth 1000%nat (div_digit Sone (1+1+1)%D)).

(* Test of Srat_to_stream *)
Eval compute in (Highlighted "10000th digits of 3 / 7").

Time Eval vm_compute in (Str_nth 10000%nat (Srat_to_stream 3 7)%bigZ).

(* Test of Sadd *)
Eval compute in (Highlighted "10000th digits of 3/7 + 5/9").

Time Eval vm_compute in (Str_nth 10000%nat 
  ((Srat_to_stream 3 7)%bigZ + (Srat_to_stream 5 9)%bigZ)%S).

(* Test of Smult *)
Eval compute in (Highlighted "100th digits of 3/7 * 5/9").

Time Eval vm_compute in (Str_nth 100%nat
  ((Srat_to_stream 3 7)%bigZ * (Srat_to_stream 5 9)%bigZ)%S).

(* Test of pi_div4 *)
Eval compute in (Highlighted "28th digits of pi/4").

Time Eval vm_compute in (Str_nth 28%nat pi_div4).

(* Test of Sinverse' *)
Eval compute in (Highlighted "4th digits of 1/(base * (3/7 + 5/9))").

Time Eval vm_compute in (Str_nth 20%nat 
  (Sinverse 1%nat ((Srat_to_stream 3 7)%bigZ + (Srat_to_stream 5 9)%bigZ)%S)).




(* restore term colors*)
Eval compute in ("\x1b[0m\n")




///


(* template

(* Test of  *)
Eval compute in (Highlighted "th digits of ").

Time Eval vm_compute in (Str_nth %nat   ).

*)

(* Here I put an error not to have create the compile file.
   It allows to play the benchmark several times withtout
   deleting the compiled file or touching the source*)
