Require Export tactic.
Require Import digits_ex.

Module Base_ex <: BASE.
Definition b := (10^10)%Z.
Theorem base_positive : (4 < b)%Z.
unfold b; compute; auto.
Qed.
End Base_ex.

Module nums_ex :=  BIGZNUMS  Base_ex.

Module Test := TACTIC nums_ex.
Import Test.

Definition ex1 := (mult pi (opp (add one one))).

Time Eval vm_compute in Ebounds ex1 50.

Time Eval vm_compute in Ebounds ex1 51.

Theorem PI_22_7_approx : 
  Rabs (PI - 22 / 7) < 1 / 100.
Proof.
ineq_tac 2%nat.
Qed.

Goal 
  (Rabs (1 /(- 887/53) - -228/51) <= 10 / 2)%R.
ineq_tac 1%nat.
Qed.

Goal 
  (Rabs (1 /(- 8871213671148155/2^53) - -2286317335542953/2^51) <= 1 / 2^53)%R.
(*ineq_tac 2%nat. (* fail more precision is needed*) *)
ineq_tac 3%nat.
Qed.


