Require Import Reals.
Require Import Fourier.
Require Import kanto_exists_uniq.


Section Kspeed.

(*variables we need in the theorem*)

Variable (a0 b0 c:R).
Variable X0:R.

(*define f f' as section variables*)
Variable a:R.
Variable b:R.
Variable f:R->R.
Variable f':R->R.

Hypothesis A0_b0_c: 2*a0*b0*c<=1.
(*Hypothesis about_eps:0<eps.*)
Hypothesis pr: forall t:R, c_I a b t -> derivable_pt f t.
Hypothesis Hder_f: forall (t:R)(H:c_I a b t), derive_pt f t (pr t H)=f' t. 
Hypothesis Hcont_f':forall y, (c_I a b y) -> continuity_pt f' y.
Hypothesis Hlim_f':forall y1 y2:R, c_I a b y1 -> c_I a b y2 ->
      Rabs (f' y1 - f' y2) <= c * (Rabs (y1-y2)).
Hypothesis Hincl: a< X0 < b.
Hypothesis Hdif_f':f' X0 <> 0 .
Hypothesis Habs_a: Rabs (/(f' X0)) <= a0.
Hypothesis Habs_b:Rabs (f X0/(f' X0)) <= b0 .
Hypothesis Hb_eps: included (c_disc X0 (2*b0)) (c_I a b).

Infix Local "^R" := Rpower (at level 30, right associativity) : R_scope.

Lemma conv_speed:
 let xstar :=  (xs a0 b0 c X0 a b f f' A0_b0_c pr Hder_f Hcont_f' Hlim_f' 
                                   Hincl Hdif_f' Habs_a Habs_b Hb_eps) in
forall p, 
Rabs (xstar - Xn X0 f f' p) <= 
  (/ 2^R (INR p - 1)) * mu a0 b0 c 0 ^ (Npow 2 p - 1) * b0 .
Proof.
intros xstar p.
apply  lim_conv_up with X0 a b (fun n =>Rabs (Xn X0 f f' (p+n)%nat - Xn X0 f f' p)).
assumption.
intro n; apply Rle_trans with (2*Bn a0 b0 c p - (2*Bn a0 b0 c p)/2^n) ;
   [apply Hdif_pos with a b pr; assumption |].
rewrite rel_bn with a0 b0 c X0 a b p.
replace (/ 2 ^R (INR p - 1) * mu a0 b0 c 0 ^ (Npow 2 p - 1) * b0) with 
(/ 2 ^R (INR p - 1) * mu a0 b0 c 0 ^ (Npow 2 p - 1) * b0+(-0)) by ring.
replace (2 * (/ 2 ^ p * mu a0 b0 c 0 ^ (Npow 2 p - 1) * b0)) with
 (/ 2 ^R (INR p - 1) * mu a0 b0 c 0 ^ (Npow 2 p - 1) * b0).
unfold Rminus; apply Rplus_le_compat_l.
apply Ropp_le_contravar.
unfold Rdiv.
repeat apply aux1.
left; apply Rinv_0_lt_compat; apply Rpow_pos; fourier.
assert (H: 0 <= mu a0 b0 c 0 <= 1).
    unfold mu; simpl; split; [apply greater0 with X0 a b f f'; assumption |trivial].
apply (proj1 (pow_le1 (mu a0 b0 c 0) (Npow 2 p - 1) H)).
apply H_b0 with X0 f f'; assumption.
left; apply Rinv_0_lt_compat; apply pow2_diff0.
repeat rewrite <-Rmult_assoc.
replace (2 * / 2 ^ p ) with (/2 ^R ( INR p-1)); [trivial|].
unfold Rminus.
rewrite Rpower_plus.
rewrite Rpower_Ropp.
rewrite Rpower_1; [|fourier].
rewrite Rpower_pow; [|fourier].
field; apply Rgt_not_eq; apply pow2_diff0.
assumption.
intros e He.
unfold xstar; unfold xs; case (kantoro_exists_b); simpl; intros xst [Hcv _].
elim (Hcv e He) ; intros N HN.
exists N; intros n Hn.
fold xs in HN.
unfold R_dist in HN |-*.
apply Rle_lt_trans with (Rabs((Xn X0 f f' (p + n) - Xn X0 f f' p) - 
  (xst - Xn X0 f f' p)));
[apply Rabs_triang_inv2|].
replace (Xn X0 f f' (p + n) - Xn X0 f f' p - (xst - Xn X0 f f'  p)) 
  with ((Xn X0 f f' (p+n)) - xst) by ring.
apply HN; omega.
Qed.

End Kspeed.


