Require Export mult_correct.
Require Import series_utils.

Module SERIES_CORRECT(Nums : NUMS).

Module Mult_correct := MULT_CORRECT(Nums).
Export Mult_correct.


CoFixpoint Scompute_series_opt_aux 
  (A : Set) 
  (compute_step : A -> A)
  (get_sum : A -> stream digit)
  (x : A)
  (r : stream digit) :=
  let x' := compute_step x in 
    series_body (Scompute_series_opt_aux A compute_step get_sum x') (r + (get_sum x'))%S.

(*
Theorem Scompute_series_opt_aux_correct : 
  forall A Un compute_step get_sum,
    (forall x, (exists y, exists n1, exists n2, Srepresents (get_sum x) (IBR y * (finite_sum Un n1 n2))) -> 
      exists y', exists n1', exists n2', Srepresents (get_sum (compute_step x)) (IBR y' * (finite_sum Un n1' n2'))) -> 



(*     (forall x, Srepresents (get_sum (compute_step x)) *)
(*       (IBR (get_y x) * (finite_sum Un (get_n x) (get_n (compute_step x))))) ->  *)

(*     (forall x s, infinit_sum (fun i => Un (i + get_n (compute_step x)))%nat s ->  *)
(*       2*Z2R b * Z2R b * Rabs (IBR (get_y x) * s) <= Z2R b - 4) -> *)
(*     (forall x, (get_y (compute_step x)) = (get_y x * Bbase)%B) -> *)

    forall x y s r vr, 
      Srepresents r vr ->
      2*Z2R b * Rabs vr <= Z2R b + 2 -> 
      infinit_sum (fun i => Un (i  )%nat) s ->
      2*Z2R b * Rabs (IBR y * s) <= Z2R b - 4 ->      
      Srepresents (Scompute_series_opt_aux A compute_step get_sum x r)
      (vr + IBR y * s).
Proof. 
assert (Hbpos := base_positive).
intros A Un compute_step get_sum get_n get_y Hle Hfin Hinf_bounds Hy.
cofix.
intros x s r vr Hrepr Hrbounds Hinf Hbounds.
str_unfold (Scompute_series_opt_aux A compute_step get_sum x r).
simpl.
fold_decomp.

set (y := get_y x).
set (n := get_n x).
set (x' := compute_step x).
set (n':= get_n x').

replace (vr + IBR y * s) with 
  (vr+ IBR y * finite_sum Un n n' + IBR y * (s - finite_sum Un n n')) by 
  (clear Scompute_series_opt_aux_correct; ring).

assert (U1 : infinit_sum (fun i : nat => Un (i + n')%nat)
  (s - finite_sum Un n n')).
clear Scompute_series_opt_aux_correct;
  apply infinit_sum_finite_sum; [apply (Hle x) | assumption].

md_tac2 d r' vr' U2 U3 Scompute_series_opt_aux_correct.
apply (Hfin x).

  rabs_intros.
  do 3 rewrite Rabs_mult.
  do 2 (rewrite Rabs_right;[ | ZR0compat]).
  apply splitted_series_bound with (IBR y * (s - finite_sum Un n n')).
    replace (IBR y * finite_sum Un n n' + IBR y * (s - finite_sum Un n n'))
    with (IBR y * s) by ring.
    apply Hbounds.

    apply Rle_trans with (Z2R b - 4); [ | R_to_Z].
    apply (Hinf_bounds x); assumption.

  rabs_intros.
  rewrite Rabs_mult.
  rewrite Rabs_right;[ assumption | ZR0compat].

destruct U3 as [U3 [U4 U5]].
constructor;[| clear Scompute_series_opt_aux_correct |clear Scompute_series_opt_aux_correct; assumption].
  replace (IBR y * (s - finite_sum Un n n') * Z2R b) with 
    (IBR (y*Bbase)%B * (s - finite_sum Un n n')) by
      (clear Scompute_series_opt_aux_correct; simpl_IBR; ring).
    subst y.
  rewrite <- (Hy x).

  apply Scompute_series_opt_aux_correct; clear Scompute_series_opt_aux_correct; try assumption.
  rabs_intros.
  rewrite <- (Rabs_right (2*Z2R b)); [| ZR0compat].
  rewrite <- Rabs_mult; assumption.

replace (2 * Z2R b * Rabs (IBR (get_y (compute_step x)) * (s- finite_sum Un n n')))
    with (2*Z2R b * Z2R b * Rabs (IBR (get_y x)* (s - finite_sum Un n n'))); [| 
      rewrite (Hy x);simpl_IBR; fold_IBR; repeat rewrite Rabs_mult;
	rewrite (Rabs_right (Z2R b)); [ring| ZR0compat]].
  apply (Hinf_bounds x); assumption.

rabs_intros.
apply Rmult_le_reg_l with (Rabs (2*Z2R b)); [ZR0compat|].
rewrite <- Rabs_mult.
rewrite Rmult_plus_distr_l.
replace (Rabs (2 * Z2R b) * 1) with ((Z2R b + 2) + (Z2R b - 2)) by  
  (rewrite Rabs_right;[ring | ZR0compat]).
apply Rabs_add.
assumption.

apply Rle_trans with (Z2R b - 4); [ | R_to_Z].
replace (Rabs (2 * Z2R b * (IBR y * (s - finite_sum Un n n') * Z2R b))) with 
  (2* Z2R b * Z2R b * Rabs (IBR y * (s - finite_sum Un n n'))).
apply (Hinf_bounds x); assumption.
repeat rewrite Rabs_mult.
rewrite (Rabs_right 2); [| ZR0compat].
rewrite (Rabs_right (Z2R b)); [| ZR0compat].
ring.
Qed.




*)

Theorem Scompute_series_opt_aux_correct : 
  forall A Un compute_step get_sum get_n get_y,
    (forall x n, n <= get_n (compute_step x))%nat -> 
    (forall x, Srepresents (get_sum (compute_step x))
      (IBR (get_y x) * (finite_sum Un (get_n x) (get_n (compute_step x))))) -> 

    (forall x s, infinit_sum (fun i => Un (i + get_n (compute_step x)))%nat s -> 
      2*Z2R b * Z2R b * Rabs (IBR (get_y x) * s) <= Z2R b - 4) ->
    (forall x, (get_y (compute_step x)) = (get_y x * Bbase)%B) ->

    forall x s r vr, 
      Srepresents r vr ->
      2*Z2R b * Rabs vr <= Z2R b + 2 -> 
      infinit_sum (fun i => Un (i + get_n x)%nat) s ->
      2*Z2R b * Rabs (IBR (get_y x)* s) <= Z2R b - 4 ->      
      Srepresents (Scompute_series_opt_aux A compute_step get_sum x r)
      (vr + IBR (get_y x) * s).
Proof. 
assert (Hbpos := base_positive).
intros A Un compute_step get_sum get_n get_y Hle Hfin Hinf_bounds Hy.
cofix.
intros x s r vr Hrepr Hrbounds Hinf Hbounds.
str_unfold (Scompute_series_opt_aux A compute_step get_sum x r).
simpl.
fold_decomp.

set (y := get_y x).
set (n := get_n x).
set (x' := compute_step x).
set (n':= get_n x').

replace (vr + IBR y * s) with 
  (vr+ IBR y * finite_sum Un n n' + IBR y * (s - finite_sum Un n n')) by 
  (clear Scompute_series_opt_aux_correct; ring).

assert (U1 : infinit_sum (fun i : nat => Un (i + n')%nat)
  (s - finite_sum Un n n')).
clear Scompute_series_opt_aux_correct;
  apply infinit_sum_finite_sum; [apply (Hle x) | assumption].

md_tac2 d r' vr' U2 U3 Scompute_series_opt_aux_correct.
apply (Hfin x).

  rabs_intros.
  do 3 rewrite Rabs_mult.
  do 2 (rewrite Rabs_right;[ | ZR0compat]).
  apply splitted_series_bound_rabs with (IBR y * (s - finite_sum Un n n')).
    replace (IBR y * finite_sum Un n n' + IBR y * (s - finite_sum Un n n'))
    with (IBR y * s) by ring.
    apply Hbounds.

    apply Rle_trans with (Z2R b - 4); [ | R_to_Z].
    apply (Hinf_bounds x); assumption.

  rabs_intros.
  rewrite Rabs_mult.
  rewrite Rabs_right;[ assumption | ZR0compat].

destruct U3 as [U3 [U4 U5]].
constructor;[| clear Scompute_series_opt_aux_correct |clear Scompute_series_opt_aux_correct; assumption].
  replace (IBR y * (s - finite_sum Un n n') * Z2R b) with 
    (IBR (y*Bbase)%B * (s - finite_sum Un n n')) by
      (clear Scompute_series_opt_aux_correct; simpl_IBR; ring).
    subst y.
  rewrite <- (Hy x).

  apply Scompute_series_opt_aux_correct; clear Scompute_series_opt_aux_correct; try assumption.
  rabs_intros.
  rewrite <- (Rabs_right (2*Z2R b)); [| ZR0compat].
  rewrite <- Rabs_mult; assumption.

replace (2 * Z2R b * Rabs (IBR (get_y (compute_step x)) * (s- finite_sum Un n n')))
    with (2*Z2R b * Z2R b * Rabs (IBR (get_y x)* (s - finite_sum Un n n'))); [| 
      rewrite (Hy x);simpl_IBR; fold_IBR; repeat rewrite Rabs_mult;
	rewrite (Rabs_right (Z2R b)); [ring| ZR0compat]].
  apply (Hinf_bounds x); assumption.

rabs_intros.
apply Rmult_le_reg_l with (Rabs (2*Z2R b)); [ZR0compat|].
rewrite <- Rabs_mult.
rewrite Rmult_plus_distr_l.
replace (Rabs (2 * Z2R b) * 1) with ((Z2R b + 2) + (Z2R b - 2)) by  
  (rewrite Rabs_right;[ring | ZR0compat]).
apply Rabs_add.
assumption.

apply Rle_trans with (Z2R b - 4); [ | R_to_Z].
replace (Rabs (2 * Z2R b * (IBR y * (s - finite_sum Un n n') * Z2R b))) with 
  (2* Z2R b * Z2R b * Rabs (IBR y * (s - finite_sum Un n n'))).
apply (Hinf_bounds x); assumption.
repeat rewrite Rabs_mult.
rewrite (Rabs_right 2); [| ZR0compat].
rewrite (Rabs_right (Z2R b)); [| ZR0compat].
ring.
Qed.

CoFixpoint Scompute_series_aux 
  (Sfinite_sum : big -> nat -> nat -> stream digit) 
  (f : big -> nat -> nat) 
  (n : nat) (y : big)
  (r : stream digit) :=
  let n' := f y n in 
    series_body (Scompute_series_aux Sfinite_sum f n' (y * Bbase)%B) (r + (Sfinite_sum y n n'))%S.

Theorem Scompute_series_aux_correct : 
  forall (Un : nat -> R) Sfinite_sum f,
    (forall n y, n <= f y n)%nat -> 
    (forall m n y , Srepresents (Sfinite_sum y m n) (IBR y * finite_sum Un m n)) -> 
    (forall n y s, infinit_sum (fun i => Un (i + f y n))%nat s -> 
      2*Z2R b * Z2R b * Rabs (IBR y * s) <= Z2R b - 4) ->
    forall s n r vr y,
      - (Z2R b + 2) <= 2 * Z2R b * vr <= Z2R b + 2 ->
      Srepresents r vr ->
      infinit_sum (fun i => (Un (i + n)%nat)) s ->
      2*Z2R b * Rabs (IBR y * s) <= Z2R b - 4 ->
      Srepresents (Scompute_series_aux Sfinite_sum f n y r) (vr + IBR y * s).
Proof.
assert (Hbpos := base_positive).
intros Un Sfinite_sum f Hfle HSfin Hbounds1.
cofix.
intros s n r vr y Hrbounds Hrepr Hinf Hbounds2.
str_unfold (Scompute_series_aux Sfinite_sum f n y r).
simpl.
fold_decomp.

replace (vr + IBR y * s) with 
  (vr+ IBR y * finite_sum Un n (f y n) + IBR y * (s - finite_sum Un n (f y n))) by 
  (clear Scompute_series_aux_correct; ring).

assert (U1 : infinit_sum (fun i : nat => Un (i + f y n)%nat)
  (s - finite_sum Un n (f y n))).
clear Scompute_series_aux_correct;
  apply infinit_sum_finite_sum; [apply Hfle | assumption].

md_tac2 d r' vr' U2 U3 Scompute_series_aux_correct.
apply HSfin.

rabs_intros.
do 3 rewrite Rabs_mult.
do 2 (rewrite Rabs_right;[ | ZR0compat]).
apply splitted_series_bound_rabs with (IBR y * (s - finite_sum Un n (f y n))).
  replace (IBR y * finite_sum Un n (f y n) + IBR y * (s - finite_sum Un n (f y n)))
    with (IBR y * s) by ring.
  apply Hbounds2.

  apply Rle_trans with (Z2R b - 4); [ | R_to_Z].
  apply Hbounds1 with n; assumption.

destruct U3 as [U3 [U4 U5]].
constructor;[| clear Scompute_series_aux_correct |clear Scompute_series_aux_correct; assumption].
  replace (IBR y * (s - finite_sum Un n (f y n)) * Z2R b) with 
    (IBR (y*Bbase)%B * (s - finite_sum Un n (f y n))) by 
    (clear Scompute_series_aux_correct; simpl_IBR; ring).
  apply Scompute_series_aux_correct; try assumption.
  replace (2 * Z2R b * Rabs (IBR (y * Bbase)%B * (s - finite_sum Un n (f y n))))
    with (2*Z2R b * Z2R b * Rabs (IBR y* (s - finite_sum Un n (f y n)))); [| 
      clear Scompute_series_aux_correct; simpl_IBR; fold_IBR; repeat rewrite Rabs_mult;
	rewrite (Rabs_right (Z2R b)); [ring| ZR0compat]].
  apply Hbounds1 with n; assumption.

rabs_intros.
apply Rmult_le_reg_l with (Rabs (2*Z2R b)); [ZR0compat|].
rewrite <- Rabs_mult.
rewrite Rmult_plus_distr_l.
replace (Rabs (2 * Z2R b) * 1) with ((Z2R b + 2) + (Z2R b - 2)) by  
  (rewrite Rabs_right;[ring | ZR0compat]).
apply Rabs_add.
assumption.

apply Rle_trans with (Z2R b - 4); [ | R_to_Z].
replace (Rabs (2 * Z2R b * (IBR y * (s - finite_sum Un n (f y n)) * Z2R b))) with 
  (2* Z2R b * Z2R b * Rabs (IBR y * (s - finite_sum Un n (f y n)))).
apply Hbounds1 with n; assumption.
repeat rewrite Rabs_mult.
rewrite (Rabs_right 2); [| ZR0compat].
rewrite (Rabs_right (Z2R b)); [| ZR0compat].
ring.
Qed.

End SERIES_CORRECT.